diff -uNrd -x CVS ircd-hybrid-7rc5/src/memory.c ircd-hybrid-7-bg/src/memory.c
--- ircd-hybrid-7rc5/src/memory.c	Thu Jul 11 20:43:24 2002
+++ ircd-hybrid-7-bg/src/memory.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: memory.c,v 7.38 2002/07/12 00:43:24 androsyn Exp $
+ *  $Id: memory.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 
diff -uNrd -x CVS ircd-hybrid-7rc5/src/messages.tab ircd-hybrid-7-bg/src/messages.tab
--- ircd-hybrid-7rc5/src/messages.tab	Tue Oct 29 22:33:25 2002
+++ ircd-hybrid-7-bg/src/messages.tab	Sat May 24 23:27:11 2003
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: messages.tab,v 7.72 2002/10/30 03:33:25 bill Exp $
+ *   $Id: messages.tab,v 1.5 2003/05/24 00:07:47 demond Exp $
  */
 
 static  char *  replies[] = {
@@ -24,23 +24,23 @@
 /* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to the %s Internet Relay Chat Network %s",
 /* 002  RPL_YOURHOST,*/ ":%s 002 %s :Your host is %s, running version %s",
 /* 003  RPL_CREATED, */ ":%s 003 %s :This server was created %s",
-/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcerkfydnxbaugl biklmnopstveIha bkloveIh",
+/* 004  RPL_MYINFO, */ 	":%s 004 %s %s %s oiwszcerkfydnxbauglqRTYS bdiklmnopstveIhacrwxzCMRS bdkloveIhw",
 /* 005  RPL_ISUPPORT, */ ":%s 005 %s %s :are supported by this server",
 /* 006 */       NULL,
 /* 007 */       NULL,
 /* 008 */       NULL,
 /* 009 */       NULL,
-/* 010  RPL_REDIR, */ ":%s 010 %s %s %d :Please use this Server/Port instead",
+/* 010  RPL_REDIR, */ 		":%s 010 %s %s %d :Please use this Server/Port instead",
 /* 011 */       NULL,
 /* 012 */       NULL,
 /* 013 */       NULL,
 /* 014 */       NULL,
-/* 015 RPL_MAP */    ":%s 015 %s :%s",
+/* 015 RPL_MAP */    		":%s 015 %s :%s",
 /* 016 */       NULL,
-/* 017 RPL_MAPEND */ ":%s 017 %s :End of /MAP",
+/* 017 RPL_MAPEND */ 		":%s 017 %s :End of /MAP",
 /* 018 */       NULL,
 /* 019 */       NULL,
-/* 020 RPL_YOURID */  ":%s 020 %s %s %s :Your ID and key is",
+/* 020 RPL_YOURID */  		":%s 020 %s %s %s :Your ID and key is",
 /* 021 */       NULL,
 /* 022 */       NULL,
 /* 023 */       NULL,
@@ -247,11 +247,11 @@
 /* 224 */       NULL,
 /* 225 RPL_STATSDLINE*/         ":%s 225 %s %c %s :%s",
 /* 226 RPL_STATSALINE*/         ":%s 226 %s %s",
-/* 227 */       NULL,
-/* 228 */       NULL,
-/* 229 */       NULL,
-/* 230 */       NULL,
-/* 231 */       NULL,
+/* 227 RPL_STATSZLINE*/			":%s 227 %s Services %s",
+/* 228 RPL_EQUIVALENTS*/		":%s 228 %s Equiv %s/%s",
+/* 229 RPL_RELAYS*/             ":%s 229 %s Relay %s",
+/* 230 RPL_USERPARMS*/			":%s 230 %s Userpar %s %s",
+/* 231 RPL_CLUSTERBRIDGE*/      ":%s 231 %s Bridge %s/%s",
 /* 232 */       NULL,
 /* 233 */       NULL,
 /* 234 RPL_SERVLIST, */ NULL,
@@ -291,7 +291,7 @@
 /* 264 */       NULL,
 /* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current local  users: %d  Max: %d",
 /* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current global users: %d  Max: %d",
-/* 267 */       NULL,
+/* 267 RPL_IDUSERS, */       	":%s 267 %s :Current identified users: %d  Max: %d",
 /* 268 */       NULL,
 /* 269 */       NULL,
 /* 270 */       NULL,
@@ -321,18 +321,18 @@
 /* 294 */       NULL,
 /* 295 */       NULL,
 /* 296 */       NULL,
-/* 297 */       NULL,
-/* 298 */       NULL,
-/* 299 */       NULL,
-/* 300 RPL_NONE, */      NULL,
-/* 301 RPL_AWAY, */      ":%s 301 %s %s :%s",
-/* 302 RPL_USERHOST, */  ":%s 302 %s :%s",
-/* 303 RPL_ISON, */     ":%s 303 %s :",
-/* 304 RPL_TEXT, */      NULL,
-/* 305 RPL_UNAWAY, */   ":%s 305 %s :You are no longer marked as being away",
-/* 306 RPL_NOWAWAY, */  ":%s 306 %s :You have been marked as being away",
+/* 297 RPL_WHOISSSL, */       	":%s 297 %s %s :is connected via SSL (secure link)",
+/* 298 RPL_WHOISCYRILLIC, */    ":%s 298 %s %s :has cyrillic-encoded nickname", 
+/* 299 */       				NULL,
+/* 300 RPL_NONE, */      		NULL,
+/* 301 RPL_AWAY, */      		":%s 301 %s %s :%s",
+/* 302 RPL_USERHOST, */  		":%s 302 %s :%s",
+/* 303 RPL_ISON, */     		":%s 303 %s :",
+/* 304 RPL_TEXT, */      		NULL,
+/* 305 RPL_UNAWAY, */   		":%s 305 %s :You are no longer marked as being away",
+/* 306 RPL_NOWAWAY, */  		":%s 306 %s :You have been marked as being away",
 /* 307 */       NULL,
-/* 308 */	NULL,
+/* 308 RPL_WHOISADMIN, */		":%s 308 %s %s :is a Server Administrator",
 /* 309 */       NULL,
 /* 310 */       NULL,
 /* 311 RPL_WHOISUSER, */        ":%s 311 %s %s %s %s * :%s",
@@ -344,16 +344,16 @@
 /* 317 RPL_WHOISIDLE, */        ":%s 317 %s %s %d %d :seconds idle, signon time",
 /* 318 RPL_ENDOFWHOIS, */       ":%s 318 %s %s :End of /WHOIS list.",
 /* 319 RPL_WHOISCHANNELS, */    ":%s 319 %s %s :%s",
-/* 320 */      NULL,
+/* 320 */      	NULL,
 /* 321 RPL_LISTSTART, */        ":%s 321 %s Channel :Users  Name",
 /* 322 RPL_LIST, */             ":%s 322 %s %s %d :%s",
 /* 323 RPL_LISTEND, */          ":%s 323 %s :End of /LIST",
 /* 324 RPL_CHANNELMODEIS, */    ":%s 324 %s %s %s %s",
 /* 325 */       NULL,
-/* 326 */       NULL,
-/* 327 */       NULL,
+/* 326 RPL_WHOISSVSHINT, */     ":%s 326 %s %s :has identified for: %s",
+/* 327 RPL_WHOISREALHOST, */	":%s 327 %s %s :logged on %s from %s",
 /* 328 */       NULL,
-/* 329 RPL_CREATIONTIME, */      ":%s 329 %s %s %lu", 
+/* 329 RPL_CREATIONTIME, */		":%s 329 %s %s %lu", 
 /* 330 */       NULL,
 /* 331 RPL_NOTOPIC, */          ":%s 331 %s %s :No topic is set.",
 /* 332 RPL_TOPIC, */            ":%s 332 %s %s :%s",
@@ -362,14 +362,14 @@
 /* 335 */       NULL,
 /* 336 */       NULL,
 /* 337 */       NULL,
-/* 338 RPL_WHOISACTUALLY */	":%s 338 %s :%s is actually %s@%s [%s]",
+/* 338 RPL_WHOISACTUALLY */		":%s 338 %s :%s is actually %s@%s [%s]",
 /* 339 */       NULL,
 /* 340 */       NULL,
 /* 341 RPL_INVITING, */         ":%s 341 %s %s %s",
 /* 342 RPL_SUMMONING, */ NULL,
 /* 343 */       NULL,
-/* 344 */       NULL,
-/* 345 */       NULL,
+/* 344 RPL_SUBSTLIST */         ":%s 344 %s %s %s %s %lu",
+/* 345 RPL_ENDOFSUBSTLIST */    ":%s 345 %s %s :End of Channel Subst List",
 /* 346 RPL_INVEXLIST */         ":%s 346 %s %s %s %s %lu",       
 /* 347 RPL_ENDOFINVEXLIST */    ":%s 347 %s %s :End of Channel Invite List",
 /* 348 RPL_EXCEPTLIST */        ":%s 348 %s %s %s %s %lu",
@@ -401,8 +401,8 @@
 /* 374 RPL_ENDOFINFO, */        ":%s 374 %s :End of /INFO list.",
 /* 375 RPL_MOTDSTART, */        ":%s 375 %s :- %s Message of the Day - ",
 /* 376 RPL_ENDOFMOTD, */        ":%s 376 %s :End of /MOTD command.",
-/* 377 */       NULL,
-/* 378 */       NULL,
+/* 377 RPL_DENYLIST, */       	":%s 377 %s %s %s %s %lu",
+/* 378 RPL_ENDOFDENYLIST, */    ":%s 378 %s %s :End of Channel Deny List",
 /* 379 */       NULL,
 /* 380 */       NULL,
 /* 381 RPL_YOUREOPER, */        ":%s 381 %s :You have entered... the Twilight Zone!.",
@@ -477,7 +477,7 @@
 /* 449 */       NULL,
 /* 450 */       NULL,
 /* 451 ERR_NOTREGISTERED, */    ":%s 451 %s :You have not registered",
-/* 452 */       NULL,
+/* 452 ERR_NOREPEATING, */      ":%s 452 %s %s :No repeating allowed (+z)",
 /* 453 */       NULL,
 /* 454 */       NULL,
 /* 455 */       NULL,
@@ -493,9 +493,9 @@
 /* 465 ERR_YOUREBANNEDCREEP, */ ":%s 465 %s :You are banned from this server- %s",
 /* 466 ERR_YOUWILLBEBANNED, */  NULL,
 /* 467 ERR_KEYSET, */           ":%s 467 %s %s :Channel key already set",
-/* 468 */       NULL,
-/* 469 */       NULL,
-/* 470 */       NULL,
+/* 468 ERR_CANNOTSENDNOTREG, */ ":%s 468 %s %s :Cannot send to channel (+M)",
+/* 469 ERR_REGNICKSCHAN, */     ":%s 469 %s %s :Cannot join channel (+R)",
+/* 470 ERR_NOCYRNICKCHAN, */    ":%s 470 %s %s :Cannot join channel (+C)",
 /* 471 ERR_CHANNELISFULL, */    ":%s 471 %s %s :Cannot join channel (+l)",
 /* 472 ERR_UNKNOWNMODE  , */    ":%s 472 %s %c :is unknown mode char to me",
 /* 473 ERR_INVITEONLYCHAN, */   ":%s 473 %s %s :Cannot join channel (+i)",
@@ -505,7 +505,7 @@
 /* 477 ERR_MODELESS, */         ":%s 477 %s %s :Channel does not support modes",
 /* 478 ERR_BANLISTFULL, */      ":%s 478 %s %s %s :Channel ban list is full",
 /* 479 ERR_BADCHANNAME */       ":%s 479 %s %s :Illegal channel name",
-/* 480 */       NULL,
+/* 480 ERR_SSLONLYCHAN */       ":%s 480 %s %s :Cannot join channel (+S)",
 /* 481 ERR_NOPRIVILEGES, */
                 ":%s 481 %s :Permission Denied - You're not an IRC operator",
 /* 482 ERR_CHANOPRIVSNEEDED, */ ":%s 482 %s %s :You're not channel operator",
@@ -513,21 +513,21 @@
 /* 484 ERR_RESTRICTED, */       ":%s 484 %s :You are restricted",
 /* 485 ERR_BANNEDNICK, */
        ":%s 485 %s :Can't change nick when banned or on a moderated channel (%s)",
-/* 486 */       NULL,
-/* 487 */       NULL,
+/* 486 ERR_CANTKICKSERVICES, */ ":%s 486 %s %s %s :Cannot kick services bots",
+/* 487 ERR_CANTDEOPSERVICES, */ ":%s 487 %s %s %s :Cannot de-op services bots",
 /* 488 */       NULL,
 /* 489 */       NULL,
 /* 490 */       NULL,
 /* 491 ERR_NOOPERHOST, */       ":%s 491 %s :Only few of mere mortals may try to enter the twilight zone",
 /* 492 */       NULL,
 /* 493 */       NULL,
-/* 494 */       NULL,
+/* 494 ERR_DENIEDFROMCHAN, */	":%s 494 %s %s :Cannot join channel (+d)",
 /* 495 */       NULL,
 /* 496 */       NULL,
 /* 497 */       NULL,
-/* 498 */       NULL,
-/* 499 */       NULL,
-/* 500 */       NULL,
+/* 498 ERR_SSLACCEPTONLY, */    ":%s 498 %s %s :Accepts messages from SSL clients only",
+/* 499 ERR_REGACCEPTONLY, */    ":%s 499 %s %s :Accepts messages from registered nicks only",
+/* 500 ERR_TOOMANYWATCH */		":%s 500 %s %s :Maximum size for WATCH-list is 128 entries",
 /* 501 ERR_UMODEUNKNOWNFLAG, */ ":%s 501 %s :Unknown MODE flag",
 /* 502 ERR_USERSDONTMATCH, */   ":%s 502 %s :Can't change mode for other users",
 /* 503 ERR_GHOSTEDCLIENT, */    ":%s 503 %s :Message could not be delivered to %s",
@@ -627,14 +627,14 @@
 /* 597 */	NULL,
 /* 598 */	NULL,
 /* 599 */	NULL,
-/* 600 */	NULL,
-/* 601 */	NULL,
-/* 602 */	NULL,
-/* 603 */	NULL,
-/* 604 */	NULL,
-/* 605 */	NULL,
-/* 606 */	NULL,
-/* 607 */	NULL,
+/* 600 RPL_LOGON */				":%s 600 %s %s %s %s %d :logged online",
+/* 601 RPL_LOGOFF */			":%s 601 %s %s %s %s %d :logged offline",
+/* 602 RPL_WATCHOFF */			":%s 602 %s %s %s %s %d :stopped watching",
+/* 603 RPL_WATCHSTAT */ 		":%s 603 %s :You have %d and are on %d WATCH entries",
+/* 604 RPL_NOWON */				":%s 604 %s %s %s %s %d :is online",
+/* 605 RPL_NOWOFF */			":%s 605 %s %s %s %s %d :is offline",
+/* 606 RPL_WATCHLIST */			":%s 606 %s :%s",
+/* 607 RPL_ENDOFWATCHLIST */	":%s 607 %s :End of WATCH %c",
 /* 608 */	NULL,
 /* 609 */	NULL,
 /* 610 */	NULL,
diff -uNrd -x CVS ircd-hybrid-7rc5/src/modules.c ircd-hybrid-7-bg/src/modules.c
--- ircd-hybrid-7rc5/src/modules.c	Thu Jul 18 03:13:46 2002
+++ ircd-hybrid-7-bg/src/modules.c	Mon Mar 10 01:09:05 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: modules.c,v 7.104 2002/07/18 07:13:46 db Exp $
+ *  $Id: modules.c,v 1.4 2003/03/10 06:09:05 demond Exp $
  */
 
 #include "stdinc.h"
@@ -31,6 +31,7 @@
 #include "client.h"
 #include "send.h"
 #include "s_conf.h"
+#include "s_serv.h"
 #include "handlers.h"
 #include "numeric.h"
 #include "parse.h"
@@ -82,6 +83,8 @@
 static void mo_modreload(struct Client*, struct Client*, int, char**);
 static void mo_modunload(struct Client*, struct Client*, int, char**);
 static void mo_modrestart(struct Client*, struct Client*, int, char**);
+static void ms_svsload(struct Client*, struct Client*, int, char**);
+static void ms_svsunload(struct Client*, struct Client*, int, char**);
 
 struct Message modload_msgtab = {
  "MODLOAD", 0, 0, 2, 0, MFLG_SLOW, 0,
@@ -98,6 +101,16 @@
   {m_unregistered, m_not_oper, m_ignore, mo_modreload}
 };
 
+struct Message svsload_msgtab = {
+  "SVSLOAD", 0, 0, 2, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_ignore, ms_svsload, m_ignore}
+};
+
+struct Message svsunload_msgtab = {
+  "SVSUNLOAD", 0, 0, 2, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_ignore, ms_svsunload, m_ignore}
+};
+
 struct Message modlist_msgtab = {
  "MODLIST", 0, 0, 0, 0, MFLG_SLOW, 0,
   {m_unregistered, m_not_oper, m_ignore, mo_modlist}
@@ -115,7 +128,9 @@
 {
 	mod_add_cmd(&modload_msgtab);
 	mod_add_cmd(&modunload_msgtab);
-        mod_add_cmd(&modreload_msgtab);
+    mod_add_cmd(&modreload_msgtab);
+    mod_add_cmd(&svsload_msgtab);
+    mod_add_cmd(&svsunload_msgtab);
 	mod_add_cmd(&modlist_msgtab);
 	mod_add_cmd(&modrestart_msgtab);
 	mod_add_cmd(&error_msgtab);
@@ -488,20 +503,20 @@
     {
       if(match(parv[1],modlist[i]->name))
       {
-        sendto_one(source_p, form_str(RPL_MODLIST), me.name, parv[0],
+        sendto_one(source_p, form_str(source_p,RPL_MODLIST), me.name, parv[0],
                    modlist[i]->name, modlist[i]->address,
                    modlist[i]->version, modlist[i]->core?"(core)":"");
       }
     }
     else
     {
-      sendto_one(source_p, form_str(RPL_MODLIST), me.name, parv[0],
+      sendto_one(source_p, form_str(source_p,RPL_MODLIST), me.name, parv[0],
                  modlist[i]->name, modlist[i]->address,
                  modlist[i]->version, modlist[i]->core?"(core)":"");
     }
   }
   
-  sendto_one(source_p, form_str(RPL_ENDOFMODLIST), me.name, parv[0]);
+  sendto_one(source_p, form_str(source_p,RPL_ENDOFMODLIST), me.name, parv[0]);
 }
 
 /* unload and reload all modules */
@@ -536,6 +551,45 @@
       modnum, num_mods);
 }
 
+static void
+ms_svsload(struct Client *client_p, struct Client *source_p, int parc, char **parv)
+{
+	char *m_bn;
+
+  if (parc < 3)
+    return;
+
+  if (hunt_server(client_p, source_p, ":%s SVSLOAD %s :%s", 
+		  1, parc, parv) != HUNTED_ISME)
+    return;
+
+  if (!find_z_conf(parv[0]))
+    return;
+
+	m_bn = irc_basename(parv[2]);
+
+	if (findmodule_byname(m_bn) == -1)
+		load_a_module(parv[2], 0, 0);
+	  
+	MyFree(m_bn);
+}
+
+static void
+ms_svsunload(struct Client *client_p, struct Client *source_p, int parc, char **parv)
+{
+  if (parc < 3)
+    return;
+
+  if (hunt_server(client_p, source_p, ":%s SVSUNLOAD %s :%s", 
+		  1, parc, parv) != HUNTED_ISME)
+    return;
+
+  if (!find_z_conf(parv[0]))
+    return;
+
+	unload_one_module(parv[2], 0);
+}
+
 #else /* STATIC_MODULES */
 
 /* load_all_modules()
@@ -558,12 +612,13 @@
 #endif
 	mod_add_cmd(&client_msgtab);
 	mod_add_cmd(&close_msgtab);
+	mod_add_cmd(&conf_msgtab);
 	mod_add_cmd(&connect_msgtab);
 #ifdef HAVE_LIBCRYPTO
 	mod_add_cmd(&challenge_msgtab);
-        mod_add_cmd(&cryptlink_msgtab);
+    mod_add_cmd(&cryptlink_msgtab);
 #endif
-        mod_add_cmd(&die_msgtab);
+    mod_add_cmd(&die_msgtab);
 	mod_add_cmd(&dmem_msgtab);
 	mod_add_cmd(&drop_msgtab);
 	mod_add_cmd(&eob_msgtab);
@@ -600,7 +655,7 @@
 	mod_add_cmd(&pong_msgtab);
 	mod_add_cmd(&post_msgtab);
 	mod_add_cmd(&get_msgtab);
-        mod_add_cmd(&put_msgtab);
+    mod_add_cmd(&put_msgtab);
 	mod_add_cmd(&quit_msgtab);
 	mod_add_cmd(&rehash_msgtab);
 	mod_add_cmd(&restart_msgtab);
@@ -611,6 +666,12 @@
 	mod_add_cmd(&squit_msgtab);
 	mod_add_cmd(&stats_msgtab);
 	mod_add_cmd(&svinfo_msgtab);
+	mod_add_cmd(&svsnick_msgtab);
+	mod_add_cmd(&svshint_msgtab);
+	mod_add_cmd(&svshost_msgtab);
+	mod_add_cmd(&svsjoin_msgtab);
+	mod_add_cmd(&svspart_msgtab);
+	mod_add_cmd(&svsmode_msgtab);
 	mod_add_cmd(&testline_msgtab);
 	mod_add_cmd(&time_msgtab);
 	mod_add_cmd(&topic_msgtab);
@@ -624,6 +685,7 @@
 	mod_add_cmd(&users_msgtab);
 	mod_add_cmd(&version_msgtab);
 	mod_add_cmd(&wallops_msgtab);
+	mod_add_cmd(&watch_msgtab);
 	mod_add_cmd(&who_msgtab);
 	mod_add_cmd(&whois_msgtab);
 	mod_add_cmd(&whowas_msgtab);
diff -uNrd -x CVS ircd-hybrid-7rc5/src/motd.c ircd-hybrid-7-bg/src/motd.c
--- ircd-hybrid-7rc5/src/motd.c	Thu Oct 10 14:49:30 2002
+++ ircd-hybrid-7-bg/src/motd.c	Mon Mar 10 01:09:05 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: motd.c,v 7.26 2002/10/10 18:49:30 androsyn Exp $
+ *  $Id: motd.c,v 1.2 2003/03/10 06:09:05 demond Exp $
  */
 
 #include "stdinc.h"
@@ -78,20 +78,20 @@
       
       if (motdToPrint->contentsOfFile == (MessageFileLine *)NULL)
         {
-          sendto_one(source_p, form_str(ERR_NOMOTD), me.name, nick);
+          sendto_one(source_p, form_str(source_p,ERR_NOMOTD), me.name, nick);
           return 0;
         }
 
-      sendto_one(source_p, form_str(RPL_MOTDSTART), me.name, nick, me.name);
+      sendto_one(source_p, form_str(source_p,RPL_MOTDSTART), me.name, nick, me.name);
 
       for(linePointer = motdToPrint->contentsOfFile;linePointer;
           linePointer = linePointer->next)
         {
           sendto_one(source_p,
-                     form_str(RPL_MOTD),
+                     form_str(source_p,RPL_MOTD),
                      me.name, nick, linePointer->line);
         }
-      sendto_one(source_p, form_str(RPL_ENDOFMOTD), me.name, nick);
+      sendto_one(source_p, form_str(source_p,RPL_ENDOFMOTD), me.name, nick);
       return 0;
       /* NOT REACHED */
       break;
diff -uNrd -x CVS ircd-hybrid-7rc5/src/numeric.c ircd-hybrid-7-bg/src/numeric.c
--- ircd-hybrid-7rc5/src/numeric.c	Fri May 24 19:34:49 2002
+++ ircd-hybrid-7-bg/src/numeric.c	Mon Mar 10 01:09:05 2003
@@ -19,13 +19,13 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: numeric.c,v 7.20 2002/05/24 23:34:49 androsyn Exp $
+ *  $Id: numeric.c,v 1.2 2003/03/10 06:09:05 demond Exp $
  */
 
 #include "stdinc.h"
 #include "setup.h"
 #include "config.h"
-
+#include "client.h"
 #include "numeric.h"
 #include "irc_string.h"
 #include "common.h"     /* NULL cripes */
@@ -40,9 +40,9 @@
  * output	- corresponding string
  * side effects	- NONE
  */
-const char* form_str(int numeric)
+char* form_str(struct Client *who, int numeric)
 {
-  const char *num_ptr;
+  char *num_ptr;
 
   assert(-1 < numeric);
   assert(numeric < ERR_LAST_ERR_MSG);
@@ -57,7 +57,9 @@
   if (num_ptr == NULL)
     num_ptr = replies[ERR_LAST_ERR_MSG];
 
-  return ((const char *) _(num_ptr));
+  if (!who) return (_(num_ptr));
+  	else
+  return (IsSetAltLocale(who)? __("alt-language", num_ptr) : _(num_ptr));
 }
 
 
diff -uNrd -x CVS ircd-hybrid-7rc5/src/packet.c ircd-hybrid-7-bg/src/packet.c
--- ircd-hybrid-7rc5/src/packet.c	Wed Oct 30 12:44:56 2002
+++ ircd-hybrid-7-bg/src/packet.c	Tue Feb  4 11:13:07 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: packet.c,v 7.90 2002/10/30 17:44:56 wiz Exp $
+ *  $Id: packet.c,v 1.4 2003/02/04 16:13:07 demond Exp $
  */
 #include "stdinc.h"
 #include "tools.h"
@@ -360,6 +360,10 @@
 #ifndef NDEBUG
   struct hook_io_data hdata;
 #endif
+#ifdef HAVE_LIBCRYPTO
+  fde_t *F = (lclient_p->fd > -1)? &fd_table[lclient_p->fd] : NULL;
+#endif
+
   if(IsDead(client_p))
     return;
   
@@ -379,6 +383,84 @@
    * I personally think it makes the code too hairy to make sane.
    *     -- adrian
    */
+#ifdef HAVE_LIBCRYPTO
+  if (F && F->ssl) {
+  	/*extern time_t CurrentTime;*/
+  	extern char *get_ssl_error(int);
+  	/*static*/ int alerted = 0;
+
+  	if (F->flags.accept_read) {
+  		int ret;
+  		/*recv(fd_r, readBuf, READBUF_SIZE, 0);*/
+  		if ((ret = SSL_accept(F->ssl)) > 0) {
+  			if (!alerted)
+  			sendto_realops_flags(FLAGS_DEBUG, L_ALL, 
+  				"SSL_accept() for %s (socket %d) wanting READ succeeded!",
+  				inetntoa((char *)&S_ADDR(F->connect.hostaddr)), F->fd);
+  			F->flags.accept_read = 0;
+  		} else if (F->accept_failures < 4) {
+  			int val = SSL_get_error(F->ssl, ret);
+  			sendto_realops_flags(FLAGS_DEBUG, L_ALL, 
+  				"SSL_accept() for %s (socket %d) wanting READ error! -- %s",
+  				inetntoa((char *)&S_ADDR(F->connect.hostaddr)), F->fd,
+  				(val == SSL_ERROR_SSL)?
+  				ERR_error_string(ERR_get_error(), NULL) :
+  				get_ssl_error(val));
+  			sendto_realops_flags(FLAGS_DEBUG, L_ALL,
+  				"BIO_sock_should_retry(): %d", BIO_sock_should_retry(ret));
+  		if (val == SSL_ERROR_SYSCALL) {
+  			int err = ERR_get_error();
+  			if (err)
+  				sendto_realops_flags(FLAGS_DEBUG, L_ALL, "ERR_get_error() -- %s",
+  					ERR_error_string(err, NULL));
+  			else
+  				sendto_realops_flags(FLAGS_DEBUG, L_ALL, "more error info -- %s",
+  					(ret == -1)? strerror(errno) : "got EOF, protocol violation");  
+  		}
+  			sendto_realops_flags(FLAGS_DEBUG, L_ALL, "SSL_state_string_long(): %s",
+  				SSL_state_string_long(F->ssl));
+  			F->accept_failures++;
+  		}
+  		length = -1; errno = EAGAIN;
+  	} else {
+  	
+#if 0  				
+  	/*if (CurrentTime % 10 == 0)*/
+  	if (!alerted) {
+  	sendto_realops_flags(FLAGS_DEBUG, L_ALL, "SSL_read() for %s (socket %d) in progress...",
+  		inetntoa((char *)&S_ADDR(F->connect.hostaddr)), F->fd);
+  	sendto_realops_flags(FLAGS_DEBUG, L_ALL, "SSL_state_string_long(): %s",
+  		SSL_state_string_long(F->ssl));
+  	}
+#endif
+  		
+  	length = SSL_read(F->ssl, readBuf, READBUF_SIZE); 
+
+  	if (length <= 0 && !alerted) {
+  		int val = SSL_get_error(F->ssl, length);
+  		/*if (CurrentTime % 10 == 0)*/
+  		sendto_realops_flags(FLAGS_DEBUG, L_ALL, 
+  			"SSL_read() for %s (socket %d) ERROR! -- %s",
+  			inetntoa((char *)&S_ADDR(F->connect.hostaddr)), F->fd,
+  			(val == SSL_ERROR_SSL)?
+  			ERR_error_string(ERR_get_error(), NULL) :
+  			get_ssl_error(val));
+  		if (val == SSL_ERROR_SYSCALL) {
+  			int err = ERR_get_error();
+  			if (err)
+  				sendto_realops_flags(FLAGS_DEBUG, L_ALL, "ERR_get_error() -- %s",
+  					ERR_error_string(err, NULL));
+  			else
+  				sendto_realops_flags(FLAGS_DEBUG, L_ALL, "more error info -- %s",
+  					(length == -1)? strerror(errno) : "got EOF, protocol violation");  
+  		} else {
+  			/*SSL_set_accept_state(F->ssl);*/
+  			errno = EAGAIN;
+  		}
+  	}}
+  	alerted = 1;
+  } else
+#endif
   length = recv(fd_r, readBuf, READBUF_SIZE, 0);
 
   if (length <= 0)
@@ -471,9 +553,6 @@
   exit_aborted_clients();
 
 }
-
-
-
 
 /*
  * client_dopacket - copy packet to client buf and parse it
diff -uNrd -x CVS ircd-hybrid-7rc5/src/parse.c ircd-hybrid-7-bg/src/parse.c
--- ircd-hybrid-7rc5/src/parse.c	Thu Oct 24 14:16:40 2002
+++ ircd-hybrid-7-bg/src/parse.c	Sat May 24 23:27:11 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: parse.c,v 7.141 2002/10/24 18:16:40 bill Exp $
+ *  $Id: parse.c,v 1.4 2003/05/25 01:31:33 demond Exp $
  */
 
 #include "stdinc.h"
@@ -42,6 +42,7 @@
 #include "vchannel.h"
 #include "memory.h"
 #include "s_serv.h"
+#include "s_misc.h"
 
 /*
  * NOTE: parse() should not be called recursively by other functions!
@@ -132,7 +133,7 @@
   char*           numeric = 0;
   struct Message* mptr;
   
-  Debug((DEBUG_DEBUG, "Parsing %s:", pbuffer));
+  Debug((DEBUG_DEBUG, "Parsing> %s", pbuffer));
 
   assert(!IsDead(client_p));
   assert(client_p->localClient->fd >= 0);
@@ -168,13 +169,42 @@
 
       if (*sender && IsServer(client_p))
         {
+          char *token, mybuf[BUFSIZE+1];
+          int hasdot = (int)strchr(sender, '.');
+          int hasatsign = (int)strchr(sender, '@');
+        
+          if (!hasdot || (hasdot && hasatsign))
+          if (ServerInfo.gateway && (token = get_bridge_token(client_p)))
+          	{
+          		int len = strlen(token);
+          		strncpy(mybuf, sender, BUFSIZE)[BUFSIZE] = 0;
+          		
+          		if (sender[0] != '.')
+          		if (HasBridgeToken(sender)) {
+          		
+          			if (ircncmp(sender, token, len) == 0) {
+          			
+          				memmove(mybuf, mybuf + len, BUFSIZE+1 - len);
+          				memset(mybuf + BUFSIZE+1 - len, 0, len);
+          			}
+          		} else {
+          		
+          			memmove(mybuf + len, mybuf, BUFSIZE+1 - len);
+          			memmove(mybuf, token, len);
+          			mybuf[BUFSIZE] = 0;
+          		}
+          		Debug((DEBUG_DEBUG, "source_p: %s", mybuf));
+          		
+          		sender = mybuf;
+          	}
+        
           from = find_client(sender);
           if (from == NULL)
-          {
-	    from = find_server(sender);
-	    if(from == NULL)
-	      from = find_id(sender);
-	  }
+          	{
+	    		from = find_server(sender);
+	    		if(from == NULL)
+	      			from = find_id(sender);
+	  		}
 
           /* Hmm! If the client corresponding to the
            * prefix is not found--what is the correct
@@ -370,7 +400,7 @@
     {
       if (!IsServer(client_p))
 	{
-	  sendto_one(client_p, form_str(ERR_NEEDMOREPARAMS),
+	  sendto_one(client_p, form_str(client_p,ERR_NEEDMOREPARAMS),
 		     me.name, BadPtr(hpara[0]) ? "*" : hpara[0], mptr->cmd);
 	  if (MyClient(client_p))
 	    return(1);
@@ -559,7 +589,7 @@
 	  assert(ptr->cmd != NULL);
 
 	  if (!((ptr->msg->flags & MFLG_HIDDEN) && !IsAdmin(source_p)))
-	    sendto_one(source_p, form_str(RPL_STATSCOMMANDS),
+	    sendto_one(source_p, form_str(source_p,RPL_STATSCOMMANDS),
 		       me.name, source_p->name, ptr->cmd,
 		       ptr->msg->count, ptr->msg->bytes,
 		       ptr->msg->rcount);
@@ -767,6 +797,8 @@
 
   if (parc < 2 || !IsServer(source_p))
     return;
+    
+  cluster_prefix(client_p, parc, parv, 1, 0, 0);
 
   /* Remap low number numerics. */
   if(numeric[0] == '0')
@@ -858,7 +890,7 @@
 m_not_oper(struct Client* client_p, struct Client* source_p,
                 int parc, char* parv[])
 {
-  sendto_one(source_p, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+  sendto_one(source_p, form_str(source_p,ERR_NOPRIVILEGES), me.name, parv[0]);
 }
 
 void
@@ -883,7 +915,7 @@
 m_registered(struct Client* client_p, struct Client* source_p,
                   int parc, char* parv[])
 {
-  sendto_one(client_p, form_str(ERR_ALREADYREGISTRED),   
+  sendto_one(client_p, form_str(client_p,ERR_ALREADYREGISTRED),   
              me.name, parv[0]); 
 }
 
diff -uNrd -x CVS ircd-hybrid-7rc5/src/restart.c ircd-hybrid-7-bg/src/restart.c
--- ircd-hybrid-7rc5/src/restart.c	Fri May 24 19:34:49 2002
+++ ircd-hybrid-7-bg/src/restart.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: restart.c,v 7.21 2002/05/24 23:34:49 androsyn Exp $
+ *  $Id: restart.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "stdinc.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/resv.c ircd-hybrid-7-bg/src/resv.c
--- ircd-hybrid-7rc5/src/resv.c	Thu Oct 10 14:49:30 2002
+++ ircd-hybrid-7-bg/src/resv.c	Mon Mar 10 01:09:06 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: resv.c,v 7.17 2002/10/10 18:49:30 androsyn Exp $
+ *  $Id: resv.c,v 1.2 2003/03/10 06:09:06 demond Exp $
  */
 
 #include "stdinc.h"
@@ -222,13 +222,13 @@
   struct ResvNick *resv_np;
 
   for(resv_cp = ResvChannelList; resv_cp; resv_cp = resv_cp->next)
-    sendto_one(source_p, form_str(RPL_STATSQLINE),
+    sendto_one(source_p, form_str(source_p,RPL_STATSQLINE),
                me.name, source_p->name,
 	       resv_cp->conf ? 'Q' : 'q',
 	       resv_cp->name, resv_cp->reason);
 
   for(resv_np = ResvNickList; resv_np; resv_np = resv_np->next)
-    sendto_one(source_p, form_str(RPL_STATSQLINE),
+    sendto_one(source_p, form_str(source_p,RPL_STATSQLINE),
                me.name, source_p->name,
 	       resv_np->conf ? 'Q' : 'q',
 	       resv_np->name, resv_np->reason);
diff -uNrd -x CVS ircd-hybrid-7rc5/src/rsa.c ircd-hybrid-7-bg/src/rsa.c
--- ircd-hybrid-7rc5/src/rsa.c	Fri May 24 19:34:49 2002
+++ ircd-hybrid-7-bg/src/rsa.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: rsa.c,v 7.25 2002/05/24 23:34:49 androsyn Exp $
+ *  $Id: rsa.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "stdinc.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_auth.c ircd-hybrid-7-bg/src/s_auth.c
--- ircd-hybrid-7rc5/src/s_auth.c	Tue Oct 29 21:56:18 2002
+++ ircd-hybrid-7-bg/src/s_auth.c	Tue Feb  4 11:13:07 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_auth.c,v 7.103 2002/10/30 02:56:18 androsyn Exp $
+ *  $Id: s_auth.c,v 1.2 2003/02/04 16:13:07 demond Exp $
  */
 
 /*
@@ -87,8 +87,25 @@
   REPORT_HOST_TOOLONG
 } ReportType;
 
+#ifdef HAVE_LIBCRYPTO
+   static void sendheader(struct Client *c, int r) {
+   		int fd = c->localClient->fd;
+   		fde_t *F = (fd > -1)? &fd_table[fd] : NULL;
+   
+   		if (F && F->ssl) {
+   			if (F->flags.accept_write)
+   				if (SSL_accept(F->ssl) > 0)
+   					F->flags.accept_write = 0;
+   			if (!F->flags.accept_read)
+   			SSL_write(F->ssl, HeaderMessages[r].message, HeaderMessages[r].length);
+   		} else {
+   			send(fd, HeaderMessages[r].message, HeaderMessages[r].length, 0);
+   		}
+   }
+#else
 #define sendheader(c, r) \
    send((c)->localClient->fd, HeaderMessages[(r)].message, HeaderMessages[(r)].length, 0)
+#endif
 
 /*
  */
